# Licensed Materials - Property of IBM
# Rational ClearCase
# (C) Copyright IBM Corp. 1996, 2014.  All Rights Reserved.
# US Government Users Restricted Rights -
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp
#


require "vob_snap_machdep.pl";


#
# Non fatal errors.
#
$SNAP_W_DEFFERED_DELETES_NOT_ENABLED =
"Deferred deletes are not enables for this vob. Snapped anyway\n";

$SNAP_E_CONF_OPEN_FAILED        = 
                       "Could not open %s. Using default parameters\n";
$SNAP_E_REP_STORE_OPEN_FAILED   = 
                       "Open of replica storage directory failed\n";
$SNAP_E_REP_DB_OPEN_FAILED      =
                       "Open of replica data base directory failed\n";
#
# Fatal errors.
#
$SNAP_F_CLEARCASE_NOT_INSTALLED   = 
          "ClearCase is not installed on this host\n";
$SNAP_F_NO_HOSTNAME               =
             "Could not get the host name for this host\n";
$SNAP_MISSING_REQUIRED_FILE       =
             "Missing a a file on the required list: %s\n";
$SNAP_REPLICA_LOCK_FAILED         = 
             "Could not lock the replica for the copy. Copied anyway.\n";
$SNAP_REPLICA_UNLOCK_FAILED         = 
        "Could not unlock the replica after the copy.Replica remains locked\n";
$SNAP_COPY_FAILED                 =
             "The snap copy failed\n";
$SNAP_RENAME_PASS                 =
    "Could not delete old snap directory because it is in use by another process. Please delete %s manually later.\n";
$SNAP_COPY_SIZE_MISMATCH          =
             "The before and after copy sizes do not match\n";
$SNAP_PREV_SNAP_DIR_NOT_DIR       =
    "A regular already exists with the same name as the snap directory %s\n";
$SNAP_DIR_SAME_NAME_AS_SNAP       =
    "A possibly non snap area directory exists with the same name %s\n";
$SNAP_OPEN_PREV_SNAP_DATA_FAILED  = 
    "Could not open the snap_data file in a previous snap area directory %s\n";
$SNAP_PREV_SNAP_DATA_MISMATCH     =
    "Previous snap directory data doesn't agree with current data %s.\n";
$SNAP_PREV_SNAP_AREA_EXISTS       =
    "A previous snap area still exists for this replica. %s\n";
$SNAP_SNAP_AREA_CREATE_FAILED     =
    "Could not make the snap area directory %s.\n";
$SNAP_SNAP_DATA_OPEN_FAILED       =
    "Could not open the snap_data file %s\n";
$SNAP_E_ROOT_FILE_OPEN_FAILED      = 
"Could not open the root notification file. No notification will be sent\n";
$SNAP_E_REP_FILE_OPEN_FAILED       =
"Could not open the replica notification file. No notification will be sent\n";
$SNAP_E_ROOT_REOPEN_FILE_FAILED    =
"Could not reopen root notification file. Notification may be incomplete\n";
$SNAP_E_REP_REOPEN_FILE_FAILED    =
"Could not reopen replica notification file. Notification may be incomplete\n";
$SNAP_E_FAILED_SNAP          = 
    "SNAPSHOT FAILED\n";
$SNAP_E_QUESTIONABLE_SNAP =
    "The snap may have been done without the vob lock in place.\n";
$SNAP_E_QUESTIONABLE_OK =
    "The snap may have been done unlocked but the data base checked ok\n";
$SNAP_E_QUESTIONABLE_BAD =
    "The snap may have been done unlocked and the dbcheck failed.\n";
$SNAP_E_QUESTIONABLE_NOTDONE =
    "The snap may have been done unlocked and a dbcheck was not done.\n";
$SNAP_E_IS_QUESTIONABLE_SNAP =
    "SNAPSHOT QUESTIONABLE\n";
$SNAP_E_UNKNOWN_STATUS_SNAP          = 
    "SNAPSHOT STATUS UNKNOWN\n";
$SNAP_NOTIFY_CAT_FILE_OPEN_FAILED    = 
    "Could not open a temporary file for building notification\n";
$SNAP_E_OPEN_FOR_SEND_FAILED  =
"Could not open one of the notification files for sending\n";
$SNAP_E_GET_REP_DBID_FAILED      =
    "Failed to obtain the replica dbid for tag: %s\n";
$SNAP_E_GET_REP_NAME_FAILED      =
    "Failed to obtain the replica name for tag: %s\n";
$SNAP_E_GET_REP_ATTR_FAILED      =
    "Failed to obtain the replica name\n";
$SNAP_E_GET_REP_RGY_FAILED      =
"Failed to obtain information from registry for replica to be snapped\n";
$SNAP_E_REPLICA_NOT_ON_HOST  =
"The replica being snapped is not on the current host\n";
$SNAP_E_SNAP_TO_NOT_EXIST  =
    "The snap_to directory %s for vob %s does not exist.\n";
$SNAP_E_SNAP_TO_NOT_WRITABLE =
    "The snap_to directory %s for vob %s is not writable\n";
$SNAP_E_SNAP_BAD_UUID_CONV =
    "The replica uuid has a bad format\n";
$SNAP_E_SNAP_DATA_FOR_DBCHECK_FAILED_N =
    "Could not open the snap_data file to do a dbcheck. %s\n";
$SNAP_E_SNAP_DATA_FOR_DBCHECK_FAILED_L =
    "%s: Could not open the snap_data file to do a dbcheck. %s\n";
$SNAP_E_DBCHECK_NOT_DONE_PREV_ERRORS_N =
    "The snapshot was not performed due to previous errors.\n";
$SNAP_E_DBCHECK_NOT_DONE_PREV_ERRORS_L =
    "%s: The snapshot was not performed due to previous errors.\n";
$SNAP_W_DBCHECK_NOT_DONE_N =
    "No dbcheck performed\n";
$SNAP_W_DBCHECK_NOT_DONE_L =
    "%s: No dbcheck performed\n";
$SNAP_E_DBCHECK_FAILED_N  =
    "Dbcheck failed\n";
$SNAP_E_DBCHECK_FAILED_L  =
    "%s: Dbcheck failed\n";
$SNAP_W_DBCHECK_SUCCEEDED_N =
    "Dbcheck succeeded\n";
$SNAP_W_DBCHECK_SUCCEEDED_L =
    "%s: Dbcheck succeeded\n";
$SNAP_E_COMPLET_BUT_DBCHECK_FAILED   =
"Snapshot completed but requested dbcheck check failed.\n";
$SNAP_E_CNG_MASTER_INFO = 
    "Could not determine if this replica is replicated or not.\n";
$SNAP_N_BANNER_LINE = "++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
$SNAP_N_VOB_TAG_NOTE              =
    "VobTag: %s\n";
$SNAP_N_HOSTNAME_NOTE              =
    "Hostname: %s\n";
$SNAP_N_REPLICA_UUID_NOTE              =
    "Replica UUID: %s\n";
$SNAP_N_FAMILY_UUID_NOTE              =
    "Family UUID: %s\n";
$SNAP_N_SUCCESSFULL_SNAP          = 
    "SNAPSHOT COMPLETED SUCCESSFULLY\n";
$SNAP_N_NOTIFY_SUBJECT = 
  "Replica Snapshot Status";
$SNAP_DBCHECKS_BANNER =
    "DBCHECKS.....\n";
$SNAP_DBCHECK_NONE =
    "NO DBCHECKS DONE\n";
$SNAP_DBCHECKS_COMPLETE =
    "DBCHECKS COMPLETE\n";
$SNAP_F_NO_TAGS     =
    "Failed to obtain local tags.\n";
$SNAP_F_FATA_BANNER =
    "NO SNAPSHOTS DONE ON THIS HOST\n";

$SNAP_W_DATE_COMMAND_FAILED         = 
    "Date command failed. Logging date as Unknown\n";
$SNAP_W_NULL_NOTIFY_LIST            = 
    "The replica %s had a null notification list\n";

 
#
# These are constants used only in this module. Some that are used in more
# than one module are defined in vob_snap_machdep.pl. All of the later have
# $MDEP_ prefixes.
#


$SNAP_PROGRAM                 = "vob_snapshot"; 
#
# Status os a particular status. Any where an error is detected during
# a snap of a replica, this variable is set to failed and a return
# done. When a replica is complete %snap_replica_status for that replica
# is set to the current $snap_status for examination after all of the
# replicas on this host are complete.
#
$SNAP_STATUS_FAILED           = 1;
$SNAP_STATUS_QUESTIONABLE     = 2;
$SNAP_STATUS_OK               = 4;
$snap_status                  = $SNAP_STATUS_OK;

#
# Information on each replica snapped or to be snapped is maintained
# in several associative arrays which are keyed by replica uuid. One
# array exists for each item of information on the replica. The arrays
# and what they mean follows.
#
# %snap_rep_vob_tag - Vob tag used for the snap
# %snap_rep_name - Replica name
# %snap_rep_host - Host where replica resides
# %snap_rep_fam_uuid - Replica family uuid
# %snap_snap_storage - Snapshot area to contain the snap
# %snap_rep_local_storage - Replica storage on local host
# %snap_rep_global_storage - Global replica storage path
# %mdep_rep_notify_list - Notification list for the replica
# %snap_rep_notification_file - Notification file for the replica
# %snap_rep_status - Replica's snap status

#
# A list of replicas that have been snapped.
# snap_snapped_replicas

#
# The name of the snapshot attribute that gets attached to replicas
# that need to be snapped. Its a string valued attribute that contains
# the replica specific parameters for the snap. These are
# dbcheck Whether to do a dbcheck on the replica AFTER all snaps
#         are complete AND on the snapped copy, not the live db. Values
#         are 'yes' and 'no'
# snap_to Where the replica gets snapped to. Actually the replica uuid
#         gets concatenated onto the end of snap_to to make the path
#         unique
# notify  List of users who want to be notified of any events that
#         occur during the snap of this replica. This list is 
#         concatenated to the list of those who want to be notified 
#         of events on any snap on this host.
# The real definition is in vob_snap_machdep.pl so all three scripts
# are sure to see the same value name. This definition is here for 
# reference only.
#
# $SNAP_REP_PARAMETERS       = "snapshot_vob_parameters"; 
#

#
# Function: snap_fatal_cleanup
# Inputs
#   None
# Outputs: 
#   None
# References: 
#   None
# Modifies:
#   None
# Returns:
#   None
# Calls: 
#   
# Description:
#   A fatal error has occurred. Do cleanup and exit. The error itself
#   has already been logged. Send out a Fatal message.
#
sub snap_fatal_cleanup {

    exit(1);
}


#
# Function: snap_check_clearcase()
# Inputs: 
#   None
# Outputs: 
#   None
# Returns:
#   1 If clearcase is installed
#   0 Otherwise
# References: 
#   None
# Modifies:
#   None
# Returns:
#   None
# Calls: 
#   &snapshot_error()
# Description:
#   Check to see if $MDEP_CLEARTOOL is installed and executable.
#   Fatal error if it is not.
#
sub snap_clearcase_installed {

    local($ret_status);        # Status return at end of CLEANUP block

    $ret_status = $RTN_NO_STATUS_SET; 

CLEANUP_CLEARCASE_INSTALLED: { # Always return at end of this block.

    # 
    # If cleartool exists and is executable, assume clearcase
    # is installed.
    #
    if( ! -x $MDEP_CLEARTOOL ) {

	$ret_status = 0;
	last CLEANUP_CLEARCASE_INSTALLED;
	
    }
    
    $ret_status = 1;

  } # CLEANUP_CLEARCASE_INSTALLED Always return here

    return $ret_status;   

}


# 
# Function: snap_setup 
# Inputs:
#   None
# Outouts:
#   None
# Returns:
#   None 
# References:
#   
# Modifies:
#   $snapshot_log_open
#   $snapshot_hostname
# Calls:
#   &snapshot_e_b
#   &snapshot_f_b
#   &snapshot_clearcase_installed
#   &snapshot_f_cleanup
# Description:
#   DO general setup. Open the log file and set its output to unbuffered.
#   Check to see if clearcase is installed. Get the local hostname. Set
#   STDERR and STDOUT to /dev/null.
#  
sub snap_setup {

    local($ret_status);     # Return status
    local($status);         # General status

CLEANUP_SETUP: { # Always return at end of this block.

    $status = &mdep_open_log_file($MDEP_LOG_FILE);
    if($status eq $RTN_FILE_OPEN_OK) {

	$mdep_log_open = $MDEP_LOG_IS_OPEN;
    }

    #
    # Check for clearcase being installed.
    #
    if(! &snap_clearcase_installed) {

	&mdep_logger($MDEP_E_B,$SNAP_F_CLEARCASE_NOT_INSTALLED);
	$ret_status = $SNAP_RTN_SETUP_FAILED;
	&snap_cleanup();
    }

    $snap_hostname = &mdep_get_hostname();
    if($snap_hostname eq "") {

	&mdep_logger($MDEP_E_B,$SNAP_F_NO_HOSTNAME);
        &snap_cleanup();
    }

    #
    # Redirect stderr and stdout
    #
    open(STDERR,">/dev/null");
    open(STDOUT,">/dev/null");

    $ret_status = $SNAP_RTN_SETUP_OK;

  } # CLEANUP_SETUP Always return here
 
    if($ret_status ne $SNAP_RTN_SETUP_OK) {

	&snap_fatal_cleanup();
    }
}



#
# Function: snap_copy()
# Inputs:
#    $vspath 
#      Vob root directory
#    $sspath 
#      Directory that gets the snapped data.
# Output:
#    None
# Returns
#    None
# References:
#    None
# Modifies:
#    $snap_status
# Calls:
#    &mdep_logger
#    &mdep_copy_list
#    &mdep_lock_vob
#    &mdep_unlock_vob
# Description:
#    Copy all of the files to be snapped from the vob storage directory
#    to the snap area. The lock is held during the copy and size checks
#    are done after. JD_TODO - something better than size.
#
sub snap_copy {

    local($vspath) = @_[0];         # Vob storage directory
    local($sspath) = @_[1];         # Target directory
    local($vtag) = @_[2];
    local($dbpath);                 # Data base path
    local(@db_objects);             # Objects in the data base directory
    local($object);                 # One of either of the above
    local($excluded);               # Excluded object marker
    local($pattern);                # Pattern for pattern matching
    local($must_have);              # One of the must have objects
    local($do_have);                # We have one of the must_have
    local(@copy_files);             # List of objects to be copied
    local($fstr);                   # General format string
    local($locked);                 # The replica is locked
    local($sopath);                 # Path for a source object
    local($topath);                 # Path for a target object
    local($status);                 # General status
    local($ssize);                  # Source file size
    local($tsize);                  # Target file size
    local($dbopen);                 # Data base directory open
    local(@lock_excludes);          # Lock exclude list
    local($ret_status);             # Return status

  
CLEANUP_COPY: {
    
    #
    # Set the data base path
    #
    $dbpath = $vspath.$MDEP_SEP.'db';

    #
    # Open the data base.
    #
    unless(opendir(DB_DIRECTORY,$dbpath)) {

	#
	# Failed. Skip this one.
	#
	&mdep_logger($MDEP_E_B,$SNAP_E_REP_DB_OPEN_FAILED);
	$snap_status = $SNAP_STATUS_FAILED;
	last CLEANUP_COPY;
    }

    $dbopen = 1;

    #
    # Read the all the entries for both directories and close them
    #
    @db_objects = readdir(DB_DIRECTORY);
    close(DB_DIRECTORY);
    $dbopen = 0;
    
    #
    # For each object in the db directory, see if its one of the excluded
    # objects. If not push it on the list of objects to copy.
    #

    @DB_EXCLUDES                   =  ("^\\.\$",
                                       "^\\.\\.\$",
                                       "^vista\\.taf\$",
                                       "^delete_list\.db\$");
                                      

    
    foreach $object (@db_objects) {

	$excluded = 0;
	foreach $pattern (@DB_EXCLUDES) {
	    if($object =~ /$pattern/) {
		#
		# Its excluded...
		#
		$excluded++; last;
	    }
	}
	if($excluded == 0) {

	    #
	    # ...Its not. Push it on the list of ones to copy.
	    #
	    push(@copy_files,'db'.$MDEP_SEP.$object);
	}
    }

    foreach $must_have (@MDEP_MUST_HAVE) {

	$do_have = 0;

	foreach $object (@copy_files) {

	    if($must_have eq $object) {

		#
		# We have this one....
		#
		$do_have++;last;
	    }
	}

	if($do_have == 0) {

	    #
	    # .... No we don't. Skip this replica. Raise the error
	    #
	    $fstr = sprintf($SNAP_MISSING_REQUIRED_FILE,$must_have);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
	    last CLEANUP_COPY;
	}
    }

    #
    # Now lock the replica.
    #
    @lock_excludes = ();
    $replace = $MDEP_NO_REPLACE_LOCK;
    $comment = "vob_snapshot locking for copy";
    $status = &mdep_lock_vob(*vtag,*vspath,*replace,*comment,*lock_excludes);
    
    #
    # If the lock was unsuccessful we do the copy anyway but log the
    # error hoping someone is watching. 
    #
    if($status ne $RTN_LOCK_OK) {
	#
	# Mark this snap as questionable.
	#
	$snap_status = $SNAP_STATUS_QUESTIONABLE;
	&mdep_logger($MDEP_E_B,$SNAP_REPLICA_LOCK_FAILED);
    }
    else {
	#
	# Mark it so we know to unlock it later.
	#
	$snap_locked_vob = $vtag;
    }

    #
    # Do the copy.
    #
    $status = &mdep_copy_list($vspath,$sspath,@copy_files);
   
    #
    # If it failed mark the snap as unsuccessful.
    #
    if($status ne $RTN_COPY_OK) {

	&mdep_logger($MDEP_E_B,$SNAP_COPY_FAILED );
	$snap_status = $SNAP_STATUS_FAILED;
	last CLEANUP_COPY;
    }
 
    # 
    # Check that each file got there ok. The check is machine dependent
    #
    foreach $object (@copy_files) {

	$sopath = $vspath.$MDEP_SEP.$object;
	$topath = $sspath.$MDEP_SEP.$object;
        $ssize = -s $sopath;
        $tsize = -s $topath;

        if(($sopath =~ /vista\.tcf/) ||
           ($sopath =~ /vista\.tjf/) ||
           ($sopath =~ /logs/)) {
 
 	       next;
        }


        #
        # Put the size for each file out to the snap_data file.
        # Mark directories in the same file.
        #
        if(-d $sopath) {
            
            print SNAPSHOT_DATA_FILE "Directory:$object\n";
        }
        #
        # Check the sizes of the source and destination files.
        #
        elsif(-e $sopath && -e $topath) {
            if(($ssize == $tsize)) {

                print SNAPSHOT_DATA_FILE "File:$object $tsize\n";
            }
            else {

                #
                # They don't match. Raise the error but don't skip remaining files.
                # Don't cleanup what was copied. The user may want to
                # look at it.
                #
                $fstr = sprintf("Size check failure: vob(%s,%d) snap(%s,%d)\n",
                                $sopath,$ssize,$topath,$tsize); 
                &mdep_logger($MDEP_E_B,$fstr);
                $snap_status = $SNAP_STATUS_FAILED;
            }
        }
        else {

            print SNAPSHOT_DATA_FILE "File:$object skipped during copy process\n";
        }
    }
        
  } # CLEANUP_COPY Always return here

    #
    # Close any directory still open
    #
    if($dbopen) {

	closedir(DB_DIRECTORY);
    }


    #
    # Unlock the vob if it was locked.
    #
    if($snap_locked_vob) {
        $comment = "vob_snapshot unlocking after copy";
	$status = &mdep_unlock_vob(*vtag,*comment);
	if($status ne $RTN_UNLOCK_OK) {
	    
	    &mdep_logger($MDEP_E_B,$SNAP_REPLICA_UNLOCK_FAILED);
	}
	$snap_locked_vob = "";
    }
}

 
#
# Function: snap_snap
# Inputs:
#   $ruuid
#     Replica uuid of replica to snap
# Output:
#   None
# Returns
#   None
# References:
#   None
# Modifies:
#   %snap_rep_vob_tag
#   %snap_rep_name
#   %snap_rep_host
#   %snap_rep_fam_uuid
#   %snap_snap_storage
#   %snap_rep_local_storage
#   %snap_rep_global_storage
#   $snap_status
# Calls:
#   &mdep_logger
#   &mdep_get_time
# Description:
#   Set up for the snap copy. If a previous snap area exists for the 
#   replica being snapped remove it. Be paranoid about checking to make
#   sure its what we think it is. Look in the snap_data file it contains
#   to check its data agains the current replica. If no snap_data file
#   exists skip the snap of this replica. Then make a new snap area
#   directory, write the appropriate information to its snap_data file,
#   do the copy, and write out success or failure to the snap_data file
#   so the recover script knows whether the area is any good or not. Set
#   $snap_status to $SNAP_STATUS_FAILED on any failure so higher levels levels
#   know.
#
sub snap_snap {

    local($rep_uuid) = @_;                # Replica's uuid
    local($sspath);                       # Snap storage path
    local($rspath);                       # Replica storage path
    local($vob_tag);                      # The vob tag
    local($rep_name);                     # Replica's name
    local($rep_host);                     # Replica's host
    local($fam_uuid);                     # Family's uuid
    local($gspath);                       # Global storage path
    local($sdpath);                       # Path for snap_data file
    local($psd_rep_uuid);                 # Replica uuid in previous snap_data
    local($psd_fam_uuid);                 # Family uuid in previous snap_data
    local($psd_status);                   # Status in previous snap_data
    local($psd_open);                     # Previous snap_data file is open
    local($sd_open);                      # Snap_data file is open
    local($line);                         # Line buffer for file reads
    local($fstr);                         # General format buffer
    local($tstamp);                       # Time stamp
    local($defdel);
    local($rpath);                        

CLEANUP_SNAP: { # Always return at end of this block.

    $vob_tag = $snap_rep_vob_tag{$rep_uuid};
    $rep_name = $snap_rep_name{$rep_uuid};
    $rep_host = $snap_rep_host{$rep_uuid};
    $fam_uuid = $snap_rep_fam_uuid{$rep_uuid};
    $sspath = $snap_snap_storage{$rep_uuid};
    $rspath = $snap_rep_local_storage{$rep_uuid};
    $gspath = $snap_rep_global_storage{$rep_uuid};
  
    $sdpath = $sspath.$MDEP_SEP.'snap_data';
    $psd_open = 0;
    $sd_open = 0;

    $defdel = &mdep_check_deferred_del($rspath);
    if($defdel ne $RTN_SET) {
        &mdep_logger($MDEP_W_B,$SNAP_W_DEFFERED_DELETES_NOT_ENABLED);
    }
    #
    # If the snap area path already exists from a previous snap it must
    # be removed but be paranoid about whether to do the remove. Check
    # the data in the area's snap_data file against what is known about
    # the replica being snapped. If it does not match do not remove the 
    # directory - skip the snap of this replica.
    #
    if( -e $sspath) {

	#
	# If its not a directory its pretty strange. Skip it anyway.
        # Only remove what we are certain about.
	#
	if(! -d $sspath) {
   
	    $fstr = sprintf($SNAP_PREV_SNAP_DIR_NOT_DIR,$sspath);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
	    last CLEANUP_SNAP;
	}
	    
	# 
	# If it doesn't contain a snap_data file assume the worst. A bug
        # has resulted in sspath getting set to a non snap area like maybe
        # /, or /usr, or.....
	# Raise the error and skip this one.
        #
	if(! -f $sdpath) {

	    $fstr = sprintf($SNAP_DIR_SAME_NAME_AS_SNAP,$sdpath);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
            last CLEANUP_SNAP;
	}
	#
	# A snap_data file is there. Now look at it and make sure
	# it says snap area is for the replica that is now being snapped.
        # If we can't open the file we can't verify the area and probably
        # can't remove it. Raise the error and skip this snap.
	#
	
	unless(open(OLD_SNAP_DATA_FILE,$sdpath)) {

	    $fstr = sprintf($SNAP_OPEN_PREV_SNAP_DATA_FAILED,$sdpath);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
            last CLEANUP_SNAP;
	}
	
	$psd_open = 1;

	#
	# Get the data from the file....
        #
	foreach $line (<OLD_SNAP_DATA_FILE>) {
	    chop $line;
	    if($line =~ /SnapStatus:(.*)/) {
		$psd_status = $1;next;
	    }
	    if($line =~ /ReplicaUUID:(.*)/) {
		$psd_rep_uuid = $1;next;
	    }
	    if($line =~ /FamilyUUID:(.*)/) {
		$psd_fam_uuid = $1;next;
	    }
	}

	close(OLD_SNAP_DATA_FILE);

	#
	# ...and check it agains known data for this replica.
	#
	if((lc($psd_rep_uuid) ne lc($rep_uuid)) ||
	   (lc($psd_fam_uuid) ne lc($fam_uuid))) {

	    # 
	    # Oh,Oh. Wrong replica snap area. Skip it.
	    #
	    $fstr = sprintf($SNAP_PREV_SNAP_DATA_MISMATCH,$sdpath);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
	    last CLEANUP_SNAP;
	}

	#
	# Old snap data for the current replica. Remove it.
	#
	&mdep_rmdir($sspath);
    }	

    #
    # Make sure the previous directory got removed if there was one.
    #
    if(-e $sspath) {

	$rpath = rename ($sspath, $sspath.$$);
	
	if($rpath == 0) {

	    $fstr = sprintf($SNAP_PREV_SNAP_AREA_EXISTS, $sspath);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
	    last CLEANUP_SNAP;
	}
	else {
	    $fstr = sprintf($SNAP_RENAME_PASS, $sspath.$$);
	    &mdep_logger($MDEP_W_L, $fstr);
	}
	    

    }
    
    #
    # Make the snap area directory.
    #
    if(mkdir($sspath,0755) == 0) {

	$fstr = sprintf($SNAP_SNAP_AREA_CREATE_FAILED,$sspath);
	&mdep_logger($MDEP_E_B,$fstr);
	$snap_status = $SNAP_STATUS_FAILED;
        last CLEANUP_SNAP;
    }

    #
    # Create the snap_data file now and write out the replica uuid and
    # family uuid. The success or failure status will be written later
    # for the recover script to determine whether the snap worked or 
    # not. In the meantime, if this script dies before the status can
    # be written, it will be able to recognize this snap area as the
    # correct one for this replica so it may be removed. Some other 
    # information is also written that may be useful to the user.
    #
    if(!open(SNAPSHOT_DATA_FILE,">$sdpath")) {

	$fstr = sprintf($SNAP_SNAP_DATA_OPEN_FAILED,$sdpath);
	&mdep_logger($MDEP_E_B,$fstr);
	$snap_status = $SNAP_STATUS_FAILED;
        last CLEANUP_SNAP;
    }

    $sd_open = 1;

    #
    # Write the information
    #
    print SNAPSHOT_DATA_FILE "SnapLocation:$sspath\n";
    print SNAPSHOT_DATA_FILE "ReplicaUUID:$rep_uuid\n";
    print SNAPSHOT_DATA_FILE "FamilyUUID:$fam_uuid\n";
    print SNAPSHOT_DATA_FILE "VobTag:$vob_tag\n";
    print SNAPSHOT_DATA_FILE "ReplicaHost:$rep_host\n";
    print SNAPSHOT_DATA_FILE "ReplicaName:$rep_name\n";
    print SNAPSHOT_DATA_FILE "LocalStorage:$rspath\n";
    print SNAPSHOT_DATA_FILE "GlobalStorage:$gspath\n";

    #
    # Write the time of the snap as well.
    #
    $tstamp = &mdep_get_time();
    if($tstamp eq "") {

	# 
	# Couldn't get the date. Raise a warning and keep on going. Put
        # the data out as Unknown.
	#
	&mdep_logger($MDEP_W_B,$SNAP_W_DATE_COMMAND_FAILED);
	$tstamp = "Unknown";
    }

    print SNAPSHOT_DATA_FILE "Snapped on $tstamp\n"; 

    #
    # All set. Do the copy.
    #
    &snap_copy($rspath,$sspath,$vob_tag);
    
    #
    # Mark success or failure in the snap_data file so the recover 
    # script will know.
    #
    if($snap_status == $SNAP_STATUS_OK) {
	print SNAPSHOT_DATA_FILE "SnapStatus:Success\n";
    }
    elsif($snap_status == $SNAP_STATUS_QUESTIONABLE) {
	print SNAPSHOT_DATA_FILE "SnapStatus:Questionable\n";
    }
    else {
	print SNAPSHOT_DATA_FILE "SnapStatus:Failed\n";
    }
  } # CLEANUP_SNAP Always return here

    if($psd_open) {

	close(OLD_SNAP_DATA_FILE);
    }
    if($sd_open) {

	close(SNAPSHOT_DATA_FILE);
    }
}


#
# Function: snap_init_snap
# Inputs:
#   rep_uuid
#     Replica uuid of snap to initialize
# Output:
#   None
# Returns
#   None
# References:
#   $snap_hostname
# Modifies:
#   $snap_status
# Calls:
#   &mdep_init_rep_file
# Description:
#   Initialize a snap. Call &mdep_init_rep_file() to do the notification 
#   file initialization and put out the initial informational strings 
#   to the file. Push this replica onto the list of replicas that have
#   been snapped and set the current snap_status to success.
#    
sub snap_init_snap {

 
    local($rep_uuid) = @_;        # The replica uuid of the snapping replica
    local($vob_tag);              # Its vob tag
    local($fam_uuid);             # And its family uuid
    local($fstr);                 # General format buffer

CLEANUP_INIT_SNAP: { # Always return at end of this block.
    #
    # Init the replica notification file.
    #
    &mdep_init_rep_file($rep_uuid);

    # 
    # Push the replica on the list of those that have been done.
    #
    push(@snap_snapped_replicas,$rep_uuid);

    #
    # Put out the informational string to the notification file
    #
    $vob_tag = $snap_rep_vob_tag{$rep_uuid};
    $fam_uuid = $snap_rep_fam_uuid{$rep_uuid};

    &mdep_logger($MDEP_N_N,$SNAP_N_BANNER_LINE);
    $fstr = sprintf($SNAP_N_VOB_TAG_NOTE,$vob_tag);
    &mdep_logger($MDEP_N_B,$fstr);

    $fstr = sprintf($SNAP_N_HOSTNAME_NOTE,$snap_hostname);
    &mdep_logger($MDEP_N_N,$fstr);

    $fstr = sprintf($SNAP_N_REPLICA_UUID_NOTE,$rep_uuid);
    &mdep_logger($MDEP_N_B,$fstr);

    $fstr = sprintf($SNAP_N_FAMILY_UUID_NOTE,$fam_uuid);
    &mdep_logger($MDEP_N_B,$fstr);

    #
    # Assume success. This gets reset on any failure.
    #
    $snap_status = $SNAP_STATUS_OK;
    $vob_snaps_done++;
 } # CLEANUP_INIT_SNAP Always return here

}

  


#
# Function: snap_end_snap
# Inputs:
#   $rep_uuid
#      Replica uuid of completing snap
# Output:
#   None
# Returns
#   None
# References:
#   $snap_status
# Modifies:
#   %snap_rep_status
# Calls:
#   &mdep_logger
# Description:
sub snap_end_snap {
  
    local($rep_uuid) = @_;      # Replica uuid 

CLEANUP_END_SNAP: { # Always return at end of this block.
    #
    # Sent the final status to the log. The status is sent to the
    # notification file later.
    #
    if($snap_status == $SNAP_STATUS_OK) {
        &mdep_logger($MDEP_N_L,$SNAP_N_SUCCESSFULL_SNAP);
    }
    elsif($snap_status == $SNAP_STATUS_FAILED) {
        &mdep_logger($MDEP_E_L,$SNAP_E_FAILED_SNAP);
        $snap_failures++;
    }
    elsif($snap_status == $SNAP_STATUS_QUESTIONABLE) {
	&mdep_logger($MDEP_E_L,$SNAP_E_IS_QUESTIONABLE_SNAP);
        $snap_failures++;
    }
    else {
	&mdep_logger($MDEP_E_L,$SNAP_E_UNKNOWN_STATUS_SNAP);
        $snap_failures++;
    }

    #
    # Set the replicas success/failure status for examination by the
    # notification sender and dbchecker.
    #
    $snap_rep_status{$rep_uuid} = $snap_status;

    #
    # Close the output file for this vob for now. Dbcheck will reopen it.
    #
    &mdep_close_rep_file();

 } # CLEANUP_END_SNAP Always return here

}



#
# Function: snap_do_snaps
# Inputs:
#   None
# Output:
#   None
# Returns
#   None
# References:
#   $snap_hostname
# Modifies:
#   %snap_rep_vob_tag
#   %mdep_rep_notify_list
#   %snap_rep_fam_uuid
#   %snap_snap_storage
#   %snap_rep_dbcheck
#   %snap_rep_local_storage
#   %snap_rep_local_storage
#   %snap_rep_host
#   %snap_rep_name
#   %mdep_rep_notification_file
# Calls:
#   &mdep_get_local_tags
#   &mdep_logger
#   &snap_notify_user
#   &mdep_command
#   &snap_init_snap
#   &snap_end_snap
#   &snap_snap
# Description:
#   This is where the real decisions are made. For all tags on the local
#   host see which ones have the snapshot parameter attribute. The ones 
#   that do get snapped and the attribute contains the replica specific
#   attributes for the snap. This function pretty much just gathers all
#   the information that will be required to do the snap, putting it in
#   globally accessible storage indexed by replica uuid. 
#
sub snap_do_snaps {
  
    local($rep_uuid);                # Replica's uuid
    local($fam_uuid);                # Family uuid
    local(@local_tags);              # List of local tags
    local($vob_tag);                 # Replica's vob tag
    local($rep_dbid);                # Its dbid
    local($rep_name);                # Its name
    local($local_storage);           # Replica's local storage
    local($global_storage);          # Replica's global storage
    local($rep_host);                # Replica's host
    local($snap_param);              # String name of the snap parameter
    local($dbcheck);                 # TO do a dbcheck or not
    local($snap_to);                 # Where to snap to
    local($notify);                  # Notification list for the replica
    local($param_found);             # Replica has a snap parameter
    local($line);                    # Line buffer for parsing
    local(@cmdbuf);                  # Return buffer fro mdep_command calls
    local($fstr);                    # General format buffer
    local($uuid_digits);             # Only digits uuid.
    local($uuidl);                   # Its length        

CLEANUP_DO_SNAPS: { # Always return at end of this block.

    #
    # First get all of the tags for replicas on this host.
    #
    $status = &mdep_get_local_tags(*snap_hostname,*local_tags);
    if($status ne $RTN_OK) {
	#
	# If we fail here do nothing. Log a fatal error and call
        # snap_fatal_cleanup
	#
	&mdep_logger($MDEP_E_B,$SNAP_F_NO_TAGS );
	&mdep_logger($MDEP_F_B,$SNAP_F_FATA_BANNER);
        &snap_cleanup();
    }

NEXT_VOB:  

    # 
    # Now go through the list looking for replicas with an attribute
    # named $SNAP_REP_PARAMETERS. These replicas are the ones to be
    # snapped. The attribute contains the replica specific parameters
    # which are described above.
    #
    foreach $vob_tag (@local_tags) {

	chop $vob_tag;

        # Eliminate empty vob_tags; perhaps generated by unexpected output
        # from lsvob (in the utility routines).
        #   An empty vob_tag is from start to end zero or more whitespace
        next if ($vob_tag =~ m/^\s*$/ );

        #
	# The only way to get a replica specific attribute is through
        # cleartool describe but it requires the replica name. The only
        # way to get the name is through the cleartool dump command.
        # In fact two cleartool dump commands. The first one gets the
        # dbid, the second uses the dbid to get the name. Ugh.
        #

        #
        # Call to mdep_is_tag_valid() is redundant at this point
	# because mdep_is_tag_valid() calls mdep_get_local_tags()
	# which has just been called above outside the current loop.
	# So we know that
	# $vob_tag is a local vob, without having to call 
	# mdep_is_tag_valid(), saving 84% of network activity 
	# in the case where there are no local vob's to be snapped.
	#
        # wjs
	#

 
	@cmdbuf = &mdep_command("$MDEP_CLEARTOOL dump vob:${vob_tag}");

        if(@cmdbuf[0] eq $MDEP_COMMAND_FAILURE) {
           
	    #
	    # Failed. Log the error and go to the next tag.
	    #
	    my $fstr = sprintf($SNAP_E_GET_REP_DBID_FAILED, $vob_tag );
	    &mdep_logger($MDEP_E_B,$fstr ); next NEXT_VOB;
	}
	
	#
	# Parse the output for the dbid.
	#
	foreach $line (@cmdbuf) {

	    chop $line;

  	    if($line =~  /this replica dbid=(\d+)/) {
		$rep_dbid = $1; last;
	    }
	}

	#
	# Now use the dbid to get the replica's name
	#
	@cmdbuf = &mdep_command(
			"$MDEP_CLEARTOOL dump dbid:${rep_dbid}\@${vob_tag}");
	if(@cmdbuf[0] eq $MDEP_COMMAND_FAILURE) {

	    #
	    # Failed. Log the error and go to the next tag.
	    #
            my $fstr = sprintf( $SNAP_E_GET_REP_NAME_FAILED, $vob_tag); 
	    &mdep_logger($MDEP_E_B, $fstr); 
	    next NEXT_VOB;
	}

	#
	# Parse the output for the name.
	#
	foreach $line (@cmdbuf) {

	    chop $line;

	    if($line =~ /mtype=replica  name=\"(.*)\"/) {
		$rep_name = $1; next;
	    }
	}

	#
	# Now we are ready to check for the attribute.
	#
	$fcmd = sprintf($MDEP_GET_SNAP_ATTR,$SNAP_REP_PARAMETERS,
			      $rep_name,$vob_tag);
	@cmdbuf = &mdep_command($fcmd);

	if(@cmdbuf[0] eq $MDEP_COMMAND_FAILURE) {

	    
	    #
	    # Failed. Log the error and go to the next tag.
	    #
	    &mdep_logger($MDEP_E_B,$SNAP_E_GET_REP_ATTR_FAILED); next NEXT_VOB;
	}

	#
	# We asked for the attribute only but parse the output anyway.
	#
	$param_found = 0;
	foreach $line (@cmdbuf) {

	    chop $line;

	    # 
	    # The parse format string is declared in vob_snap_machep.pl
	    #
	    if($line =~ /$SNAP_REP_PARAMETERS_PARSE/) {
		$dbcheck = $1;
		$snap_to = $2;
		$notify = $3;
		$param_found = 1;
		last;
	    }
	}
	# 
	# If this replica doesn't have the parameter go to the next
	# one.
	#
        if(!$param_found) {

	    next NEXT_VOB;
	}

	#
	# Now we have a replica to snap. Get all the data we need
        # from the registry.
	#
        # set following env. for tagged massage output
        # for lsvob -l command
        $ENV{'CLEARCASE_ENABLE_ATE_MESSAGES'} = "TRUE";

	@cmdbuf = 
           &mdep_command("$MDEP_LSVOB -long ${vob_tag}");
	if(@cmdbuf[0] eq $MDEP_COMMAND_FAILURE) {
	    
	    #
	    # Failed. Log the error and go to the next tag.
	    #
	    &mdep_logger($MDEP_E_B,$SNAP_E_GET_REP_RGY_FAILED); next NEXT_VOB;
	}

	#
	# Parse for what we need.
	#
	while($_ = shift(@cmdbuf)) {
            
	    chop;

            if(/^TAG_ID:cmd!!\d+!!698:END_ID/) {
                shift(@cmdbuf);
                $_ = shift(@cmdbuf);
                if(/^TAG_VALUES:(.*):END_VALUES/) {
                    $rep_uuid = $1; next;
                }
            }

            if(/^TAG_ID:cmd!!\d+!!697:END_ID/) {
                shift(@cmdbuf);
                $_ = shift(@cmdbuf);
                if(/^TAG_VALUES:(.*):END_VALUES/) {
                    $fam_uuid = $1; next;
                }
            }

            if(/^TAG_ID:cmd!!\d+!!696:END_ID/) {
                shift(@cmdbuf);
                $_ = shift(@cmdbuf);
                if(/^TAG_VALUES:(.*):END_VALUES/) {
                    $local_storage = $1; next;
                }
            }

            if(/^TAG_ID:cmd!!\d+!!687:END_ID/) {
                shift(@cmdbuf);
                $_ = shift(@cmdbuf);
                if(/^TAG_VALUES:(.*):END_VALUES/) {
                    $global_storage = $1; next;
                }
            }

            if(/^TAG_ID:cmd!!\d+!!695:END_ID/) {
                shift(@cmdbuf);
                $_ = shift(@cmdbuf);
                if(/^TAG_VALUES:(.*):END_VALUES/) {
                    $rep_host = $1; next;
                }
            }

	} 
   
        # change back to untagged message
        if(exists($ENV{'CLEARCASE_ENABLE_ATE_MESSAGES'})) {
            delete $ENV{"CLEARCASE_ENABLE_ATE_MESSAGES"};
        }

	#
	# Now we have everything for this replica. Check to make sure
        # everything looks OK, put the data that will be needed later in 
        # the various associative arrays indexed by replica uuid and 
        # start the snap.
        #

	# 
	# We know the user intended this replica should be snapped at this
        # point. We are going to do some checking of the parameters and
        # if something isn't right those users interested in this replica 
        # should be notified. Up to now all notification has gone to the 
        # root list only. So, we need to run $snap_init_snap() now. Initialize
        # anything it needs before the call - mainly the global information
        # that snap_init_snap() writes out to the replica notification file
        # describing which replica is being snapped. 
	#
	$snap_rep_vob_tag{$rep_uuid} = $vob_tag;
	$mdep_rep_notify_list{$rep_uuid} = $notify;
	$snap_rep_fam_uuid{$rep_uuid} = $fam_uuid;
	#
	# Init the snap...
	#
	&snap_init_snap($rep_uuid);
	$snap_rep_notification_file{$rep_uuid} = $mdep_rep_notify_file;

	#
	# The snap is now init'd. Any failures from this point on must
        # set $snap_status to $SNAP_STATUS_FAILED and result in a call 
        # to &snap_end_snap
	#
	
	#
	# Do a sanity check on the hostname of the machine this script is 
	# running on and the host the vob believes it resides on. Fail if
	# they disagree.
	#

	$is_same_host = 0;
	$this_hostname = "";

	#
	# Use the alternate_hostnames file, if it exists. wjs
	#

	undef @alternate_hostames;
	if ( open ALTERNATE_HOSTNAMES, 
	     $MDEP_ATRIA_CONF_DIR.$MDEP_SEP."alternate_hostnames" ) {
	    while(<ALTERNATE_HOSTNAMES>){
		chomp;
		push @alternate_hostames,$_;
	    };
	    close ALTERNATE_HOSTNAMES;
	};
	push @alternate_hostames,$snap_hostname;
	for $this_hostname (@alternate_hostames){
	    if(mdep_same_hosts($this_hostname,$rep_host)) {
		$is_same_host = 1;
		last;
	    }
	}
	if (!$is_same_host){
	    $fstr = sprintf($SNAP_E_REPLICA_NOT_ON_HOST,$vob_tag);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
	    &snap_end_snap($rep_uuid);
	    next NEXT_VOB;
	}

	#
	# Check the snap_to directory. It needs to exist and be
        # writable.
	#
	if(! -e $snap_to) {
	    $fstr = sprintf($SNAP_E_SNAP_TO_NOT_EXIST,$snap_to,$vob_tag);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
	    &snap_end_snap($rep_uuid);
	    next NEXT_VOB;
	}
	if(! -w $snap_to) {
	    $fstr = sprintf($SNAP_E_SNAP_TO_NOT_WRITABLE,$snap_to,$vob_tag);
	    &mdep_logger($MDEP_E_B,$fstr);
	    $snap_status = $SNAP_STATUS_FAILED;
	    &snap_end_snap($rep_uuid);
	    next NEXT_VOB;
	}
	
	#
	# Set the remaining global information indexed by replica uuid.
	# First attach the replica uuid to the snap_to directory. This 
        # is the real directory the snap goes to. It is sure to be unique.
	# Take out any punctuation to make the name uniform across platforms.
        # Different platforms like different things in file names but 
        # [0-9a-fA-f] is valid on all.
	#
        ($uuid_digits = $rep_uuid) =~ s/\W//g;
	$snap_snap_storage{$rep_uuid}=
	    $snap_to.$MDEP_SEP.$uuid_digits;
        #
	# Check its length just to be sure.
        #
	$uuidl = length($uuid_digits);

	if($uuidl != 32) {

	    #
	    # I wouldn't be comfortable using this string as a basis
            # for making a decision to nuke the previous directory in
	    # snap_snap. Lets play it safe. Raise the error and go
            # to the next one. We should really never hit this anyhow.
	    &mdep_logger($MDEP_E_B,$SNAP_E_SNAP_BAD_UUID_CONV);
	    $snap_status = $SNAP_STATUS_FAILED;
	    &snap_end_snap($rep_uuid);
	    next NEXT_VOB;
	}
	$snap_rep_dbcheck{$rep_uuid} = $dbcheck;
	$snap_rep_local_storage{$rep_uuid} = $local_storage;
	$snap_rep_global_storage{$rep_uuid} = $global_storage;
	$snap_rep_host{$rep_uuid} = $rep_host;
	$snap_rep_name{$rep_uuid} = $rep_name;
	
	#
	# Do the snap.
	#
	&snap_snap($rep_uuid);
	
	#
	# End this one up and go to the next.
	#
	&snap_end_snap($rep_uuid);
	
    }

  } # CLEANUP_DO_SNAPS Always return here
}


#
# Function: snap_do_dbcheck
# Inputs:
#   None
# Output:
#   None
# Returns
#   None
# References:
#   %snap_snap_storage
#   %snap_snapped_replicas
#   %snap_rep_notification_file
# Modifies:
#   %snap_dbcheck_status 
#   %snap_rep_status
# Calls:
#   &mdep_reopen_rep_file
#   &mdep_dodbcheck
#   &mdep_logger
#   &mdep_close_rep_file
# Description
#   Determine if a dbcheck should be done and do it if needed. Update the
#   snap_data file on the snap area and the replica's notification file.
#
sub snap_do_dbchecks {

    local($rep_uuid);        # Replica uuid
    local($nfile);           # Replica's notification file.
    local($fstr);            # General format buffer
    local($dbstatus);        # Returned from the &mdep_dodbcheck
    local($snap_storage);    # Snap Storage directory
    local($rep_status);      # Replica's snap status
    local($snap_data);       # Snap data path
    local($dbcheck);         # To do a dbcheck or not
    local($vob_tag);
    local($dbchecks_done) = 0;
    

CLEANUP_DO_DBCHECKS: { # Always return at end of this block.
    if($vob_snaps_done) {
        &mdep_logger($MDEP_N_L,$SNAP_DBCHECKS_BANNER);
    }
    foreach $rep_uuid (@snap_snapped_replicas) {
	$vob_tag = $snap_rep_vob_tag{$rep_uuid};
        #
	# Get the snap storage directory to pass to the dbchecker.
	#
	$snap_storage = $snap_snap_storage{$rep_uuid};
        $snap_data = $snap_storage.$MDEP_SEP.'snap_data';
	#
	# Reopen the replica's notification file so log events go
        # to it rather than the root'd.
	#
	$nfile = $snap_rep_notification_file{$rep_uuid};
	&mdep_reopen_rep_file($nfile);
	$rep_status = $snap_rep_status{$rep_uuid};
	
	$dbcheck = $snap_rep_dbcheck{$rep_uuid};
            
	if($rep_status == $SNAP_STATUS_FAILED) {

	    #
	    # If the snap failed, no point doing a dbcheck
	    #
	    $fstr = sprintf($SNAP_E_DBCHECK_NOT_DONE_PREV_ERRORS_L,$vob_tag);
	    &mdep_logger($MDEP_E_N,$fstr);
	    &mdep_logger($MDEP_E_N,$SNAP_E_DBCHECK_NOT_DONE_PREV_ERRORS_N);
	    $snap_dbcheck_status{$rep_uuid} = "NotDone";
	    print SNAPSHOT_DATA_FILE "Dbcheck:NotDone\n";
	}
	elsif(!open(SNAPSHOT_DATA_FILE,">>$snap_data")) {
 
	    #
	    # Open the snap_data file. If it fails we can't tell the recover 
	    # side what we did here so don't do anything. Raise the error 
	    # though. We really shouldn't have gotten here if the snap_data 
	    # file isn't there.
            #
	    $fstr = sprintf($SNAP_E_SNAP_DATA_FOR_DBCHECK_FAILED_L,
			    $vob_tag,$snap_data);
	    &mdep_logger($MDEP_W_L,$fstr);
	    $fstr = sprintf($SNAP_E_SNAP_DATA_FOR_DBCHECK_FAILED_N,$snap_data);
	    &mdep_logger($MDEP_W_N,$fstr);
	    $snap_dbcheck_status{$rep_uuid} = "NotDone"; next;
	}
	elsif( lc($dbcheck) eq "no") {

	    #
	    # Don't do one if one wasn't asked for.
	    #
	    $fstr = sprintf($SNAP_W_DBCHECK_NOT_DONE_L,$vob_tag);
	    &mdep_logger($MDEP_W_L,$fstr);
	    &mdep_logger($MDEP_W_N,$SNAP_W_DBCHECK_NOT_DONE_N);
	    $snap_dbcheck_status{$rep_uuid} = "NotDone";
	    print SNAPSHOT_DATA_FILE "Dbcheck:NotDone\n"; next;
	}
	else {
		
	    #
	    # Do the dbcheck....
	    #
	    $dbchecks_done++;
	    $dbstatus = &mdep_dodbcheck($snap_storage);

	    if($dbstatus ne $RTN_DBCHECK_OK) {

		$rep_status = $SNAP_STATUS_FAILED;
	    }
	    #
	    # .... and report the status.
	    #
	    if($dbstatus eq $RTN_DBCHECK_FAILED) {

		#
		# Failed....
		#
		$fstr = sprintf($SNAP_E_DBCHECK_FAILED_L,$vob_tag);
		&mdep_logger($MDEP_E_L,$fstr);
		&mdep_logger($MDEP_E_N,$SNAP_E_DBCHECK_FAILED_N);
		$snap_dbcheck_status{$rep_uuid} = "Failed";
		print SNAPSHOT_DATA_FILE "Dbcheck:Failed\n";
	    }
	    else {
		
		# 
		# ....or Not.
		#
		$fstr = sprintf($SNAP_W_DBCHECK_SUCCEEDED_L,$vob_tag);
		&mdep_logger($MDEP_N_L,$fstr);
		&mdep_logger($MDEP_N_N,$SNAP_W_DBCHECK_SUCCEEDED_N);
		$snap_dbcheck_status{$rep_uuid} = "Succeeded";
		print SNAPSHOT_DATA_FILE "Dbcheck:Succeeded\n";
	    }
	}
		
	#
	# Update the global status for snap_final_status to look at.
	#
	$snap_rep_status{$rep_uuid} = $rep_status;

	#
	# Close the notification file for now. We are done with it.
	#
	&mdep_close_rep_file();
	
		# Failed....
	#
	# And finally close the snap_data file.
	#
	close(SNAPSHOT_DATA_FILE);
    
    }
    if($vob_snaps_done) {
        if($dbchecks_done) {
       	    &mdep_logger($MDEP_N_L,$SNAP_DBCHECKS_COMPLETE);
        }
        else {
	    &mdep_logger($MDEP_N_L,$SNAP_DBCHECK_NONE);
        }
    }
  } # CLEANUP_DO_DBCHECKS Always return here
}      


#
# Function: snap_final_status
# Inputs:
#   None
# Output:
#   None
# Returns
#   None
# References:
#   %snap_rep_notification_file
#   @snap_snapped_replicas
#   %snap_rep_status
#   %snap_rep_dbcheck
#   %snap_dbcheck_status
# Modifies:
#   None
# Calls:
#   &mdep_reopen_rep_file
#   &mdep_logger
#   &mdep_close_rep_file
# Description
#   Do the final update of the notification file for all of the snapped 
#   replicas. Puts out the final status and a banner to separate multiple
#   notifications to the same user.
#
sub snap_final_status {

    local($rep_uuid);          # Replica's uuid
    local($nfile);             # Replica's notification file
    local($status);            # General status
    local($dbcheck);           # Was a dbcheck requested
    local($dbcheck_status);    # Dbcheck's status
    local($rep_status);        # Replica's snap status
    local($putonlist);

CLEANUP_FINAL_STATUS: { # Always return at end of this block.

    &mdep_put_root_on_user_list();
    foreach $rep_uuid (@snap_snapped_replicas) {

	#
	# Gets turned off if success and no notification on success.
	#
	$putonlist = 1; 
       
	#
	# Open the replica's notification file so logging can go
        # there rather than root's
	#
	$nfile = $snap_rep_notification_file{$rep_uuid};
	&mdep_reopen_rep_file($nfile);
	#
	# Update the replica's notification file with information
        # on snap status and dbcheck status. Put out a banner clearly
	# highlighting success or failure.
	#
	$rep_status = $snap_rep_status{$rep_uuid};
	$dbcheck = $snap_rep_dbcheck{$rep_uuid};
        $dbcheck_status = $snap_dbcheck_status{$rep_uuid};
	if($rep_status ==  $SNAP_STATUS_FAILED) {

	    #
	    # Something along the way failed.
	    #
	    &mdep_logger($MDEP_E_N,$SNAP_E_FAILED_SNAP);
	}
	elsif($rep_status == $SNAP_STATUS_QUESTIONABLE) {

	    &mdep_logger($MDEP_E_N,$SNAP_E_IS_QUESTIONABLE_SNAP);
	}
	elsif($rep_status == $SNAP_STATUS_OK) {
	    # The snap completed successfully but look at the dbcheck
	    # status. Be specific. If a dbcheck was requested but failed 
            # Say the snap completed successfully but the requested
            # dbcheck failed.
	    	
	    if($dbcheck_status eq "Failed") {
		
		&mdep_logger($MDEP_E_N,$SNAP_E_COMPLET_BUT_DBCHECK_FAILED);
	    }
	    else {
		#
		# Everything went fine.
		#
		&mdep_logger($MDEP_N_N,$SNAP_N_SUCCESSFULL_SNAP);
		if(lc($mdep_confirm_success) eq 'no') {

		    $putonlist = 0;
		}
	    }
	}
        else {
            #
            # Shouldn't happen
            #
            &mdep_logger($MDEP_E_N,$SNAP_E_UNKNOWN_STATUS_SNAP);
        }
	#
	# Log the pretty end banner to the notification file. This separates
        # notifications for different replicas from one another.
	#
	&mdep_logger($MDEP_N_N,$SNAP_N_BANNER_LINE);

	#
	# Close out the replica file.
	#
	&mdep_close_rep_file();
	if($putonlist) {

	    &mdep_put_on_user_list($rep_uuid,$nfile);
	}
    }
  } # CLEANUP_FINAL_STATUS Always return here
}
      
#
# Function: snap_cleanup
# Inputs:
#   None
# Output:
#   None
# Returns
#   None
# References:
#
# Modifies:
#   None
# Calls:
#   &snap_final_status
#   &mdep_send_notification 
# Description 
#   Wraps things up. Calls snap_final_status to put final status out to 
#   each replica's notification file and then calls sna-send_notification
#   to send all of the notifications out. Closes out the 
#
sub snap_cleanup {

    &snap_final_status();
    &mdep_send_notification();
    close(SNAPSHOT_LOG);
    if($snap_failures) {
        if( $MDEP_MACHINE eq 'NT') {
            system("$MDEP_IMSGLOG failed $MDEP_LOG_FILE");
        }
        exit(1);
    }
    exit(0);
}

# CLEARCASE_ENABLE_ATE_MESSAGES environment variable, 
# might cause printing a lot of extra messages 
# which confuse this perl script. This is why we
# need to remove this variable from the 
# ENV array. 
delete $ENV{"CLEARCASE_ENABLE_ATE_MESSAGES"};

$CLEARCASE_LIGHT = "";
$vercmd = "$MDEP_CLEARTOOL -version";

if(&mdep_command_s(*vercmd,*cmdbuf)) {
    &param_error("Could not obtain ClearCase version information\n");
    &param_cleartool_message(*command,*cmdbuf);
    exit(1);
}

while($_ = shift(@cmdbuf)) {
    chop;

    if(/ClearCase LT/) {
        $CLEARCASE_LIGHT = TRUE;
    }
}


sub cntrl_c_catch {
    if($snap_locked_vob) {
        $comment = "vob_snapshot unlocking on control-C";
        mdep_unlock_vob(*snap_locked_vob,*comment);
    }
       
    die "Control-C seen, exiting\n";
}

if (scalar(@ARGV) != 0) {
    print "vob_snapshot takes no arguments\n";
    exit(1);
}

$SIG{INT} = \&cntrl_c_catch;

$ENV{'CLEARCASE_PROCFLAGS'} = "no_abort_op";
$ENV{'CG_PROCFLAGS'} = "no_process";
&mdep_init_root_file();
&snap_setup();
&snap_do_snaps();
&snap_do_dbchecks();
&snap_cleanup();




 

   

  


